/*
 * Copyright (c) 2002 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: flip.h,v 1.2.2.1 2004/02/08 03:24:18 zinnia Exp $
 */

#ifndef __SDL_FLIP_FLIP_H
#define __SDL_FLIP_FLIP_H

#include "SDL.h"
#include "SDL_thread.h"
#include "property.h"
#include "timebase.h"
#include "util.h"
#include "drivers.h"

#ifdef USE_OPENGL
#include <GL/gl.h>
#include <GL/glu.h>
#endif

#ifndef ABS
#define ABS(x) ((x) < 0 ? -(x) : (x))
#endif

#define EXTRACT_PIXEL(s,v,c) ((Uint8)(((v & s->format->c##mask) >> s->format->c##shift) <<s->format->c##loss))
#define COMPOSE_PIXEL(s,r,g,b) (((Uint8)(r) << (s)->format->Rshift ) | ((Uint8)(g) << (s)->format->Gshift) | ((Uint8)(b) << (s)->format->Bshift))

extern void doEvents();
extern void doUpdate();
#ifdef USE_OPENGL
extern GLuint GetTexture(GLfloat* texture);

extern void SDL_GL_Enter2DMode();
extern void SDL_GL_Leave2DMode();
extern GLuint SDL_GL_LoadTexture(SDL_Surface* src, GLfloat* texcoord);
#endif

#endif
